
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
import cpu_process_list
class process_list(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-RAS-operational - based on the path /cpu-state/process-list. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: CPU utilization summary and list of all the process
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__list_cpu_load_average_one_min','__list_cpu_load_average_five_min','__list_cpu_load_average_fifteen_min','__list_cpu_util_current','__list_cpu_util_current_user','__list_cpu_util_current_kernel','__list_cpu_util_current_iowait','__cpu_process_list',)

  _yang_name = 'process-list'
  _rest_name = 'process-list'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__list_cpu_util_current_user = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-user", rest_name="list-cpu-util-current-user", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    self.__list_cpu_load_average_five_min = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-five-min", rest_name="list-cpu-load-average-five-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    self.__cpu_process_list = YANGDynClass(base=YANGListType("cpu_process_id",cpu_process_list.cpu_process_list, yang_name="cpu-process-list", rest_name="cpu-process-list", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='cpu-process-id', extensions={u'tailf-common': {u'callpoint': u'RAS-cpu-process-list', u'cli-suppress-show-path': None}}), is_container='list', yang_name="cpu-process-list", rest_name="cpu-process-list", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'RAS-cpu-process-list', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='list', is_config=False)
    self.__list_cpu_load_average_fifteen_min = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-fifteen-min", rest_name="list-cpu-load-average-fifteen-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    self.__list_cpu_util_current_kernel = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-kernel", rest_name="list-cpu-util-current-kernel", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    self.__list_cpu_load_average_one_min = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-one-min", rest_name="list-cpu-load-average-one-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    self.__list_cpu_util_current = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current", rest_name="list-cpu-util-current", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    self.__list_cpu_util_current_iowait = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-iowait", rest_name="list-cpu-util-current-iowait", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'cpu-state', u'process-list']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'cpu-state', u'process-list']

  def _get_list_cpu_load_average_one_min(self):
    """
    Getter method for list_cpu_load_average_one_min, mapped from YANG variable /cpu_state/process_list/list_cpu_load_average_one_min (decimal64)

    YANG Description: CPU load average in the last one minute
    """
    return self.__list_cpu_load_average_one_min
      
  def _set_list_cpu_load_average_one_min(self, v, load=False):
    """
    Setter method for list_cpu_load_average_one_min, mapped from YANG variable /cpu_state/process_list/list_cpu_load_average_one_min (decimal64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_list_cpu_load_average_one_min is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_list_cpu_load_average_one_min() directly.

    YANG Description: CPU load average in the last one minute
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-one-min", rest_name="list-cpu-load-average-one-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """list_cpu_load_average_one_min must be of a type compatible with decimal64""",
          'defined-type': "decimal64",
          'generated-type': """YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-one-min", rest_name="list-cpu-load-average-one-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)""",
        })

    self.__list_cpu_load_average_one_min = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_list_cpu_load_average_one_min(self):
    self.__list_cpu_load_average_one_min = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-one-min", rest_name="list-cpu-load-average-one-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)


  def _get_list_cpu_load_average_five_min(self):
    """
    Getter method for list_cpu_load_average_five_min, mapped from YANG variable /cpu_state/process_list/list_cpu_load_average_five_min (decimal64)

    YANG Description: CPU load average in the last five minute
    """
    return self.__list_cpu_load_average_five_min
      
  def _set_list_cpu_load_average_five_min(self, v, load=False):
    """
    Setter method for list_cpu_load_average_five_min, mapped from YANG variable /cpu_state/process_list/list_cpu_load_average_five_min (decimal64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_list_cpu_load_average_five_min is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_list_cpu_load_average_five_min() directly.

    YANG Description: CPU load average in the last five minute
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-five-min", rest_name="list-cpu-load-average-five-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """list_cpu_load_average_five_min must be of a type compatible with decimal64""",
          'defined-type': "decimal64",
          'generated-type': """YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-five-min", rest_name="list-cpu-load-average-five-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)""",
        })

    self.__list_cpu_load_average_five_min = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_list_cpu_load_average_five_min(self):
    self.__list_cpu_load_average_five_min = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-five-min", rest_name="list-cpu-load-average-five-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)


  def _get_list_cpu_load_average_fifteen_min(self):
    """
    Getter method for list_cpu_load_average_fifteen_min, mapped from YANG variable /cpu_state/process_list/list_cpu_load_average_fifteen_min (decimal64)

    YANG Description: CPU load average in the last fifteen minute
    """
    return self.__list_cpu_load_average_fifteen_min
      
  def _set_list_cpu_load_average_fifteen_min(self, v, load=False):
    """
    Setter method for list_cpu_load_average_fifteen_min, mapped from YANG variable /cpu_state/process_list/list_cpu_load_average_fifteen_min (decimal64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_list_cpu_load_average_fifteen_min is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_list_cpu_load_average_fifteen_min() directly.

    YANG Description: CPU load average in the last fifteen minute
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-fifteen-min", rest_name="list-cpu-load-average-fifteen-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """list_cpu_load_average_fifteen_min must be of a type compatible with decimal64""",
          'defined-type': "decimal64",
          'generated-type': """YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-fifteen-min", rest_name="list-cpu-load-average-fifteen-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)""",
        })

    self.__list_cpu_load_average_fifteen_min = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_list_cpu_load_average_fifteen_min(self):
    self.__list_cpu_load_average_fifteen_min = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-load-average-fifteen-min", rest_name="list-cpu-load-average-fifteen-min", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)


  def _get_list_cpu_util_current(self):
    """
    Getter method for list_cpu_util_current, mapped from YANG variable /cpu_state/process_list/list_cpu_util_current (decimal64)

    YANG Description: Current total CPU utilization percentage
    """
    return self.__list_cpu_util_current
      
  def _set_list_cpu_util_current(self, v, load=False):
    """
    Setter method for list_cpu_util_current, mapped from YANG variable /cpu_state/process_list/list_cpu_util_current (decimal64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_list_cpu_util_current is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_list_cpu_util_current() directly.

    YANG Description: Current total CPU utilization percentage
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current", rest_name="list-cpu-util-current", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """list_cpu_util_current must be of a type compatible with decimal64""",
          'defined-type': "decimal64",
          'generated-type': """YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current", rest_name="list-cpu-util-current", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)""",
        })

    self.__list_cpu_util_current = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_list_cpu_util_current(self):
    self.__list_cpu_util_current = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current", rest_name="list-cpu-util-current", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)


  def _get_list_cpu_util_current_user(self):
    """
    Getter method for list_cpu_util_current_user, mapped from YANG variable /cpu_state/process_list/list_cpu_util_current_user (decimal64)

    YANG Description: Current CPU utilization percentage of user processes
    """
    return self.__list_cpu_util_current_user
      
  def _set_list_cpu_util_current_user(self, v, load=False):
    """
    Setter method for list_cpu_util_current_user, mapped from YANG variable /cpu_state/process_list/list_cpu_util_current_user (decimal64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_list_cpu_util_current_user is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_list_cpu_util_current_user() directly.

    YANG Description: Current CPU utilization percentage of user processes
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-user", rest_name="list-cpu-util-current-user", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """list_cpu_util_current_user must be of a type compatible with decimal64""",
          'defined-type': "decimal64",
          'generated-type': """YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-user", rest_name="list-cpu-util-current-user", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)""",
        })

    self.__list_cpu_util_current_user = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_list_cpu_util_current_user(self):
    self.__list_cpu_util_current_user = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-user", rest_name="list-cpu-util-current-user", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)


  def _get_list_cpu_util_current_kernel(self):
    """
    Getter method for list_cpu_util_current_kernel, mapped from YANG variable /cpu_state/process_list/list_cpu_util_current_kernel (decimal64)

    YANG Description: Current CPU utilization percentage of kernel processes
    """
    return self.__list_cpu_util_current_kernel
      
  def _set_list_cpu_util_current_kernel(self, v, load=False):
    """
    Setter method for list_cpu_util_current_kernel, mapped from YANG variable /cpu_state/process_list/list_cpu_util_current_kernel (decimal64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_list_cpu_util_current_kernel is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_list_cpu_util_current_kernel() directly.

    YANG Description: Current CPU utilization percentage of kernel processes
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-kernel", rest_name="list-cpu-util-current-kernel", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """list_cpu_util_current_kernel must be of a type compatible with decimal64""",
          'defined-type': "decimal64",
          'generated-type': """YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-kernel", rest_name="list-cpu-util-current-kernel", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)""",
        })

    self.__list_cpu_util_current_kernel = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_list_cpu_util_current_kernel(self):
    self.__list_cpu_util_current_kernel = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-kernel", rest_name="list-cpu-util-current-kernel", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)


  def _get_list_cpu_util_current_iowait(self):
    """
    Getter method for list_cpu_util_current_iowait, mapped from YANG variable /cpu_state/process_list/list_cpu_util_current_iowait (decimal64)

    YANG Description: Current CPU utilization percentage of iowait
    """
    return self.__list_cpu_util_current_iowait
      
  def _set_list_cpu_util_current_iowait(self, v, load=False):
    """
    Setter method for list_cpu_util_current_iowait, mapped from YANG variable /cpu_state/process_list/list_cpu_util_current_iowait (decimal64)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_list_cpu_util_current_iowait is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_list_cpu_util_current_iowait() directly.

    YANG Description: Current CPU utilization percentage of iowait
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-iowait", rest_name="list-cpu-util-current-iowait", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """list_cpu_util_current_iowait must be of a type compatible with decimal64""",
          'defined-type': "decimal64",
          'generated-type': """YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-iowait", rest_name="list-cpu-util-current-iowait", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)""",
        })

    self.__list_cpu_util_current_iowait = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_list_cpu_util_current_iowait(self):
    self.__list_cpu_util_current_iowait = YANGDynClass(base=RestrictedPrecisionDecimalType(precision=2), is_leaf=True, yang_name="list-cpu-util-current-iowait", rest_name="list-cpu-util-current-iowait", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='decimal64', is_config=False)


  def _get_cpu_process_list(self):
    """
    Getter method for cpu_process_list, mapped from YANG variable /cpu_state/process_list/cpu_process_list (list)

    YANG Description: CPU utilization list of all the process
    """
    return self.__cpu_process_list
      
  def _set_cpu_process_list(self, v, load=False):
    """
    Setter method for cpu_process_list, mapped from YANG variable /cpu_state/process_list/cpu_process_list (list)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_cpu_process_list is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_cpu_process_list() directly.

    YANG Description: CPU utilization list of all the process
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGListType("cpu_process_id",cpu_process_list.cpu_process_list, yang_name="cpu-process-list", rest_name="cpu-process-list", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='cpu-process-id', extensions={u'tailf-common': {u'callpoint': u'RAS-cpu-process-list', u'cli-suppress-show-path': None}}), is_container='list', yang_name="cpu-process-list", rest_name="cpu-process-list", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'RAS-cpu-process-list', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='list', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """cpu_process_list must be of a type compatible with list""",
          'defined-type': "list",
          'generated-type': """YANGDynClass(base=YANGListType("cpu_process_id",cpu_process_list.cpu_process_list, yang_name="cpu-process-list", rest_name="cpu-process-list", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='cpu-process-id', extensions={u'tailf-common': {u'callpoint': u'RAS-cpu-process-list', u'cli-suppress-show-path': None}}), is_container='list', yang_name="cpu-process-list", rest_name="cpu-process-list", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'RAS-cpu-process-list', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='list', is_config=False)""",
        })

    self.__cpu_process_list = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_cpu_process_list(self):
    self.__cpu_process_list = YANGDynClass(base=YANGListType("cpu_process_id",cpu_process_list.cpu_process_list, yang_name="cpu-process-list", rest_name="cpu-process-list", parent=self, is_container='list', user_ordered=False, path_helper=self._path_helper, yang_keys='cpu-process-id', extensions={u'tailf-common': {u'callpoint': u'RAS-cpu-process-list', u'cli-suppress-show-path': None}}), is_container='list', yang_name="cpu-process-list", rest_name="cpu-process-list", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'callpoint': u'RAS-cpu-process-list', u'cli-suppress-show-path': None}}, namespace='urn:brocade.com:mgmt:brocade-RAS-operational', defining_module='brocade-RAS-operational', yang_type='list', is_config=False)

  list_cpu_load_average_one_min = __builtin__.property(_get_list_cpu_load_average_one_min)
  list_cpu_load_average_five_min = __builtin__.property(_get_list_cpu_load_average_five_min)
  list_cpu_load_average_fifteen_min = __builtin__.property(_get_list_cpu_load_average_fifteen_min)
  list_cpu_util_current = __builtin__.property(_get_list_cpu_util_current)
  list_cpu_util_current_user = __builtin__.property(_get_list_cpu_util_current_user)
  list_cpu_util_current_kernel = __builtin__.property(_get_list_cpu_util_current_kernel)
  list_cpu_util_current_iowait = __builtin__.property(_get_list_cpu_util_current_iowait)
  cpu_process_list = __builtin__.property(_get_cpu_process_list)


  _pyangbind_elements = {'list_cpu_load_average_one_min': list_cpu_load_average_one_min, 'list_cpu_load_average_five_min': list_cpu_load_average_five_min, 'list_cpu_load_average_fifteen_min': list_cpu_load_average_fifteen_min, 'list_cpu_util_current': list_cpu_util_current, 'list_cpu_util_current_user': list_cpu_util_current_user, 'list_cpu_util_current_kernel': list_cpu_util_current_kernel, 'list_cpu_util_current_iowait': list_cpu_util_current_iowait, 'cpu_process_list': cpu_process_list, }


