
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class forward(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-interface - based on the path /protocol/cfm/y1731/test-profile/test-profile-params/slm-threshold/forward. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__thr_fwd_avg_value','__thr_fwd_max_value',)

  _yang_name = 'forward'
  _rest_name = 'forward'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__thr_fwd_max_value = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967295']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(4294967295), is_leaf=True, yang_name="thr-fwd-max-value", rest_name="maximum", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure ETH-SLM Forward Maximum Threshold value', u'cli-full-command': None, u'alt-name': u'maximum', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='uint32', is_config=True)
    self.__thr_fwd_avg_value = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967295']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(4294967295), is_leaf=True, yang_name="thr-fwd-avg-value", rest_name="average", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure ETH-SLM Forward Average Threshold value', u'cli-full-command': None, u'alt-name': u'average', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='uint32', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'protocol', u'cfm', u'y1731', u'test-profile', u'test-profile-params', u'slm-threshold', u'forward']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'protocol', u'cfm', u'y1731', u'test-profile', u'threshold', u'forward']

  def _get_thr_fwd_avg_value(self):
    """
    Getter method for thr_fwd_avg_value, mapped from YANG variable /protocol/cfm/y1731/test_profile/test_profile_params/slm_threshold/forward/thr_fwd_avg_value (uint32)
    """
    return self.__thr_fwd_avg_value
      
  def _set_thr_fwd_avg_value(self, v, load=False):
    """
    Setter method for thr_fwd_avg_value, mapped from YANG variable /protocol/cfm/y1731/test_profile/test_profile_params/slm_threshold/forward/thr_fwd_avg_value (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_thr_fwd_avg_value is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_thr_fwd_avg_value() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967295']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(4294967295), is_leaf=True, yang_name="thr-fwd-avg-value", rest_name="average", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure ETH-SLM Forward Average Threshold value', u'cli-full-command': None, u'alt-name': u'average', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='uint32', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """thr_fwd_avg_value must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967295']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(4294967295), is_leaf=True, yang_name="thr-fwd-avg-value", rest_name="average", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure ETH-SLM Forward Average Threshold value', u'cli-full-command': None, u'alt-name': u'average', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='uint32', is_config=True)""",
        })

    self.__thr_fwd_avg_value = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_thr_fwd_avg_value(self):
    self.__thr_fwd_avg_value = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967295']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(4294967295), is_leaf=True, yang_name="thr-fwd-avg-value", rest_name="average", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure ETH-SLM Forward Average Threshold value', u'cli-full-command': None, u'alt-name': u'average', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='uint32', is_config=True)


  def _get_thr_fwd_max_value(self):
    """
    Getter method for thr_fwd_max_value, mapped from YANG variable /protocol/cfm/y1731/test_profile/test_profile_params/slm_threshold/forward/thr_fwd_max_value (uint32)
    """
    return self.__thr_fwd_max_value
      
  def _set_thr_fwd_max_value(self, v, load=False):
    """
    Setter method for thr_fwd_max_value, mapped from YANG variable /protocol/cfm/y1731/test_profile/test_profile_params/slm_threshold/forward/thr_fwd_max_value (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_thr_fwd_max_value is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_thr_fwd_max_value() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967295']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(4294967295), is_leaf=True, yang_name="thr-fwd-max-value", rest_name="maximum", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure ETH-SLM Forward Maximum Threshold value', u'cli-full-command': None, u'alt-name': u'maximum', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='uint32', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """thr_fwd_max_value must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967295']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(4294967295), is_leaf=True, yang_name="thr-fwd-max-value", rest_name="maximum", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure ETH-SLM Forward Maximum Threshold value', u'cli-full-command': None, u'alt-name': u'maximum', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='uint32', is_config=True)""",
        })

    self.__thr_fwd_max_value = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_thr_fwd_max_value(self):
    self.__thr_fwd_max_value = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4294967295']}), default=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32)(4294967295), is_leaf=True, yang_name="thr-fwd-max-value", rest_name="maximum", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Configure ETH-SLM Forward Maximum Threshold value', u'cli-full-command': None, u'alt-name': u'maximum', u'cli-full-no': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='uint32', is_config=True)

  thr_fwd_avg_value = __builtin__.property(_get_thr_fwd_avg_value, _set_thr_fwd_avg_value)
  thr_fwd_max_value = __builtin__.property(_get_thr_fwd_max_value, _set_thr_fwd_max_value)


  _pyangbind_elements = {'thr_fwd_avg_value': thr_fwd_avg_value, 'thr_fwd_max_value': thr_fwd_max_value, }


