
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class addpath_advertise(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-common-def - based on the path /routing-system/router/router-bgp/address-family/ipv6/ipv6-unicast/default-vrf/neighbor/af-ipv6-neighbor-peergroup-holder/af-ipv6-neighbor-peergroup/additional-paths/addpath-advertise. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__addpath_adv_best','__addpath_adv_groupbest','__addpath_adv_all',)

  _yang_name = 'addpath-advertise'
  _rest_name = 'advertise'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__addpath_adv_all = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="addpath-adv-all", rest_name="all", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Advertise all(Max: 16)', u'alt-name': u'all'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='empty', is_config=True)
    self.__addpath_adv_groupbest = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="addpath-adv-groupbest", rest_name="group-best", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Advertise group-best', u'alt-name': u'group-best'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='empty', is_config=True)
    self.__addpath_adv_best = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': [u'2..16']}), is_leaf=True, yang_name="addpath-adv-best", rest_name="best", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u"Advertise best 'n'", u'alt-name': u'best'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='uint8', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'routing-system', u'router', u'router-bgp', u'address-family', u'ipv6', u'ipv6-unicast', u'default-vrf', u'neighbor', u'af-ipv6-neighbor-peergroup-holder', u'af-ipv6-neighbor-peergroup', u'additional-paths', u'addpath-advertise']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'router', u'bgp', u'address-family', u'ipv6', u'unicast', u'neighbor', u'af-ipv6-neighbor-peergroup', u'additional-paths', u'advertise']

  def _get_addpath_adv_best(self):
    """
    Getter method for addpath_adv_best, mapped from YANG variable /routing_system/router/router_bgp/address_family/ipv6/ipv6_unicast/default_vrf/neighbor/af_ipv6_neighbor_peergroup_holder/af_ipv6_neighbor_peergroup/additional_paths/addpath_advertise/addpath_adv_best (uint8)
    """
    return self.__addpath_adv_best
      
  def _set_addpath_adv_best(self, v, load=False):
    """
    Setter method for addpath_adv_best, mapped from YANG variable /routing_system/router/router_bgp/address_family/ipv6/ipv6_unicast/default_vrf/neighbor/af_ipv6_neighbor_peergroup_holder/af_ipv6_neighbor_peergroup/additional_paths/addpath_advertise/addpath_adv_best (uint8)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_addpath_adv_best is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_addpath_adv_best() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': [u'2..16']}), is_leaf=True, yang_name="addpath-adv-best", rest_name="best", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u"Advertise best 'n'", u'alt-name': u'best'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='uint8', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """addpath_adv_best must be of a type compatible with uint8""",
          'defined-type': "uint8",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': [u'2..16']}), is_leaf=True, yang_name="addpath-adv-best", rest_name="best", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u"Advertise best 'n'", u'alt-name': u'best'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='uint8', is_config=True)""",
        })

    self.__addpath_adv_best = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_addpath_adv_best(self):
    self.__addpath_adv_best = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..255']}, int_size=8), restriction_dict={'range': [u'2..16']}), is_leaf=True, yang_name="addpath-adv-best", rest_name="best", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u"Advertise best 'n'", u'alt-name': u'best'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='uint8', is_config=True)


  def _get_addpath_adv_groupbest(self):
    """
    Getter method for addpath_adv_groupbest, mapped from YANG variable /routing_system/router/router_bgp/address_family/ipv6/ipv6_unicast/default_vrf/neighbor/af_ipv6_neighbor_peergroup_holder/af_ipv6_neighbor_peergroup/additional_paths/addpath_advertise/addpath_adv_groupbest (empty)
    """
    return self.__addpath_adv_groupbest
      
  def _set_addpath_adv_groupbest(self, v, load=False):
    """
    Setter method for addpath_adv_groupbest, mapped from YANG variable /routing_system/router/router_bgp/address_family/ipv6/ipv6_unicast/default_vrf/neighbor/af_ipv6_neighbor_peergroup_holder/af_ipv6_neighbor_peergroup/additional_paths/addpath_advertise/addpath_adv_groupbest (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_addpath_adv_groupbest is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_addpath_adv_groupbest() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="addpath-adv-groupbest", rest_name="group-best", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Advertise group-best', u'alt-name': u'group-best'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """addpath_adv_groupbest must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="addpath-adv-groupbest", rest_name="group-best", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Advertise group-best', u'alt-name': u'group-best'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='empty', is_config=True)""",
        })

    self.__addpath_adv_groupbest = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_addpath_adv_groupbest(self):
    self.__addpath_adv_groupbest = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="addpath-adv-groupbest", rest_name="group-best", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Advertise group-best', u'alt-name': u'group-best'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='empty', is_config=True)


  def _get_addpath_adv_all(self):
    """
    Getter method for addpath_adv_all, mapped from YANG variable /routing_system/router/router_bgp/address_family/ipv6/ipv6_unicast/default_vrf/neighbor/af_ipv6_neighbor_peergroup_holder/af_ipv6_neighbor_peergroup/additional_paths/addpath_advertise/addpath_adv_all (empty)
    """
    return self.__addpath_adv_all
      
  def _set_addpath_adv_all(self, v, load=False):
    """
    Setter method for addpath_adv_all, mapped from YANG variable /routing_system/router/router_bgp/address_family/ipv6/ipv6_unicast/default_vrf/neighbor/af_ipv6_neighbor_peergroup_holder/af_ipv6_neighbor_peergroup/additional_paths/addpath_advertise/addpath_adv_all (empty)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_addpath_adv_all is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_addpath_adv_all() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=YANGBool, is_leaf=True, yang_name="addpath-adv-all", rest_name="all", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Advertise all(Max: 16)', u'alt-name': u'all'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='empty', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """addpath_adv_all must be of a type compatible with empty""",
          'defined-type': "empty",
          'generated-type': """YANGDynClass(base=YANGBool, is_leaf=True, yang_name="addpath-adv-all", rest_name="all", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Advertise all(Max: 16)', u'alt-name': u'all'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='empty', is_config=True)""",
        })

    self.__addpath_adv_all = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_addpath_adv_all(self):
    self.__addpath_adv_all = YANGDynClass(base=YANGBool, is_leaf=True, yang_name="addpath-adv-all", rest_name="all", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Advertise all(Max: 16)', u'alt-name': u'all'}}, namespace='urn:brocade.com:mgmt:brocade-bgp', defining_module='brocade-bgp', yang_type='empty', is_config=True)

  addpath_adv_best = __builtin__.property(_get_addpath_adv_best, _set_addpath_adv_best)
  addpath_adv_groupbest = __builtin__.property(_get_addpath_adv_groupbest, _set_addpath_adv_groupbest)
  addpath_adv_all = __builtin__.property(_get_addpath_adv_all, _set_addpath_adv_all)


  _pyangbind_elements = {'addpath_adv_best': addpath_adv_best, 'addpath_adv_groupbest': addpath_adv_groupbest, 'addpath_adv_all': addpath_adv_all, }


