
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class cngn_mon_del_pkt(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-sysdiag-operational - based on the path /tm-state/cngn-mon-del-pkt. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.

  YANG Description: TM delete pkt config
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__delete_pkt_threshold','__delete_log_interval',)

  _yang_name = 'cngn-mon-del-pkt'
  _rest_name = 'cngn-mon-del-pkt'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__delete_pkt_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="delete-pkt-threshold", rest_name="delete-pkt-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-sysdiag-operational', defining_module='brocade-sysdiag-operational', yang_type='uint32', is_config=False)
    self.__delete_log_interval = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="delete-log-interval", rest_name="delete-log-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-sysdiag-operational', defining_module='brocade-sysdiag-operational', yang_type='uint16', is_config=False)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'tm-state', u'cngn-mon-del-pkt']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'tm-state', u'cngn-mon-del-pkt']

  def _get_delete_pkt_threshold(self):
    """
    Getter method for delete_pkt_threshold, mapped from YANG variable /tm_state/cngn_mon_del_pkt/delete_pkt_threshold (uint32)

    YANG Description: Delete VOQ packet threshold
    """
    return self.__delete_pkt_threshold
      
  def _set_delete_pkt_threshold(self, v, load=False):
    """
    Setter method for delete_pkt_threshold, mapped from YANG variable /tm_state/cngn_mon_del_pkt/delete_pkt_threshold (uint32)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_delete_pkt_threshold is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_delete_pkt_threshold() directly.

    YANG Description: Delete VOQ packet threshold
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="delete-pkt-threshold", rest_name="delete-pkt-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-sysdiag-operational', defining_module='brocade-sysdiag-operational', yang_type='uint32', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """delete_pkt_threshold must be of a type compatible with uint32""",
          'defined-type': "uint32",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="delete-pkt-threshold", rest_name="delete-pkt-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-sysdiag-operational', defining_module='brocade-sysdiag-operational', yang_type='uint32', is_config=False)""",
        })

    self.__delete_pkt_threshold = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_delete_pkt_threshold(self):
    self.__delete_pkt_threshold = YANGDynClass(base=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), is_leaf=True, yang_name="delete-pkt-threshold", rest_name="delete-pkt-threshold", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-sysdiag-operational', defining_module='brocade-sysdiag-operational', yang_type='uint32', is_config=False)


  def _get_delete_log_interval(self):
    """
    Getter method for delete_log_interval, mapped from YANG variable /tm_state/cngn_mon_del_pkt/delete_log_interval (uint16)

    YANG Description: Delete VOQ packet log interval 
    """
    return self.__delete_log_interval
      
  def _set_delete_log_interval(self, v, load=False):
    """
    Setter method for delete_log_interval, mapped from YANG variable /tm_state/cngn_mon_del_pkt/delete_log_interval (uint16)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_delete_log_interval is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_delete_log_interval() directly.

    YANG Description: Delete VOQ packet log interval 
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="delete-log-interval", rest_name="delete-log-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-sysdiag-operational', defining_module='brocade-sysdiag-operational', yang_type='uint16', is_config=False)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """delete_log_interval must be of a type compatible with uint16""",
          'defined-type': "uint16",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="delete-log-interval", rest_name="delete-log-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-sysdiag-operational', defining_module='brocade-sysdiag-operational', yang_type='uint16', is_config=False)""",
        })

    self.__delete_log_interval = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_delete_log_interval(self):
    self.__delete_log_interval = YANGDynClass(base=RestrictedClassType(base_type=int, restriction_dict={'range': ['0..65535']},int_size=16), is_leaf=True, yang_name="delete-log-interval", rest_name="delete-log-interval", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-sysdiag-operational', defining_module='brocade-sysdiag-operational', yang_type='uint16', is_config=False)

  delete_pkt_threshold = __builtin__.property(_get_delete_pkt_threshold)
  delete_log_interval = __builtin__.property(_get_delete_log_interval)


  _pyangbind_elements = {'delete_pkt_threshold': delete_pkt_threshold, 'delete_log_interval': delete_log_interval, }


