
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class stop(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-dot1ag - based on the path /cfm-config/protocol/cfm/y1731/test-profile/test-profile-params/stop. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__stop_type','__stop_time',)

  _yang_name = 'stop'
  _rest_name = 'stop'

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__stop_time = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'([0-1][0-9]|[2][0-3]){1}(:[0-5][0-9]){2}'}), is_leaf=True, yang_name="stop-time", rest_name="stop-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Specify stop time in hh:mm:ss', u'cli-drop-node-name': None, u'cli-break-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='time-in-hhmmss', is_config=True)
    self.__stop_type = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'after': {'value': 2}, u'at': {'value': 1}},), is_leaf=True, yang_name="stop-type", rest_name="stop-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Specify stop type as at/after sometime', u'cli-drop-node-name': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='schedule-type', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'cfm-config', u'protocol', u'cfm', u'y1731', u'test-profile', u'test-profile-params', u'stop']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'protocol', u'cfm', u'y1731', u'test-profile', u'stop']

  def _get_stop_type(self):
    """
    Getter method for stop_type, mapped from YANG variable /cfm_config/protocol/cfm/y1731/test_profile/test_profile_params/stop/stop_type (schedule-type)
    """
    return self.__stop_type
      
  def _set_stop_type(self, v, load=False):
    """
    Setter method for stop_type, mapped from YANG variable /cfm_config/protocol/cfm/y1731/test_profile/test_profile_params/stop/stop_type (schedule-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_stop_type is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_stop_type() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'after': {'value': 2}, u'at': {'value': 1}},), is_leaf=True, yang_name="stop-type", rest_name="stop-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Specify stop type as at/after sometime', u'cli-drop-node-name': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='schedule-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """stop_type must be of a type compatible with schedule-type""",
          'defined-type': "brocade-dot1ag:schedule-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'after': {'value': 2}, u'at': {'value': 1}},), is_leaf=True, yang_name="stop-type", rest_name="stop-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Specify stop type as at/after sometime', u'cli-drop-node-name': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='schedule-type', is_config=True)""",
        })

    self.__stop_type = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_stop_type(self):
    self.__stop_type = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'after': {'value': 2}, u'at': {'value': 1}},), is_leaf=True, yang_name="stop-type", rest_name="stop-type", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Specify stop type as at/after sometime', u'cli-drop-node-name': None, u'cli-incomplete-command': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='schedule-type', is_config=True)


  def _get_stop_time(self):
    """
    Getter method for stop_time, mapped from YANG variable /cfm_config/protocol/cfm/y1731/test_profile/test_profile_params/stop/stop_time (time-in-hhmmss)
    """
    return self.__stop_time
      
  def _set_stop_time(self, v, load=False):
    """
    Setter method for stop_time, mapped from YANG variable /cfm_config/protocol/cfm/y1731/test_profile/test_profile_params/stop/stop_time (time-in-hhmmss)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_stop_time is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_stop_time() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'([0-1][0-9]|[2][0-3]){1}(:[0-5][0-9]){2}'}), is_leaf=True, yang_name="stop-time", rest_name="stop-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Specify stop time in hh:mm:ss', u'cli-drop-node-name': None, u'cli-break-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='time-in-hhmmss', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """stop_time must be of a type compatible with time-in-hhmmss""",
          'defined-type': "brocade-dot1ag:time-in-hhmmss",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'([0-1][0-9]|[2][0-3]){1}(:[0-5][0-9]){2}'}), is_leaf=True, yang_name="stop-time", rest_name="stop-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Specify stop time in hh:mm:ss', u'cli-drop-node-name': None, u'cli-break-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='time-in-hhmmss', is_config=True)""",
        })

    self.__stop_time = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_stop_time(self):
    self.__stop_time = YANGDynClass(base=RestrictedClassType(base_type=unicode, restriction_dict={'pattern': u'([0-1][0-9]|[2][0-3]){1}(:[0-5][0-9]){2}'}), is_leaf=True, yang_name="stop-time", rest_name="stop-time", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Specify stop time in hh:mm:ss', u'cli-drop-node-name': None, u'cli-break-sequence-commands': None}}, namespace='urn:brocade.com:mgmt:brocade-dot1ag', defining_module='brocade-dot1ag', yang_type='time-in-hhmmss', is_config=True)

  stop_type = __builtin__.property(_get_stop_type, _set_stop_type)
  stop_time = __builtin__.property(_get_stop_time, _set_stop_time)


  _pyangbind_elements = {'stop_type': stop_type, 'stop_time': stop_time, }


