
from operator import attrgetter
import pyangbind.lib.xpathhelper as xpathhelper
from pyangbind.lib.yangtypes import RestrictedPrecisionDecimalType, RestrictedClassType, TypedListType
from pyangbind.lib.yangtypes import YANGBool, YANGListType, YANGDynClass, ReferenceType
from pyangbind.lib.base import PybindBase
from decimal import Decimal
from bitarray import bitarray
import __builtin__
class next_hop_tvf_domain_container(PybindBase):
  """
  This class was auto-generated by the PythonClass plugin for PYANG
  from YANG module brocade-common-def - based on the path /routing-system/route-map/content/precedence/set/next-hop-tvf-domain-container. Each member element of
  the container is represented as a class variable - with a specific
  YANG type.
  """
  __slots__ = ('_pybind_generated_by', '_path_helper', '_yang_name', '_rest_name', '_extmethods', '__next_hop_tvf_domain','__strip_vlan_tvf',)

  _yang_name = 'next-hop-tvf-domain-container'
  _rest_name = ''

  _pybind_generated_by = 'container'

  def __init__(self, *args, **kwargs):

    path_helper_ = kwargs.pop("path_helper", None)
    if path_helper_ is False:
      self._path_helper = False
    elif path_helper_ is not None and isinstance(path_helper_, xpathhelper.YANGPathHelper):
      self._path_helper = path_helper_
    elif hasattr(self, "_parent"):
      path_helper_ = getattr(self._parent, "_path_helper", False)
      self._path_helper = path_helper_
    else:
      self._path_helper = False

    extmethods = kwargs.pop("extmethods", None)
    if extmethods is False:
      self._extmethods = False
    elif extmethods is not None and isinstance(extmethods, dict):
      self._extmethods = extmethods
    elif hasattr(self, "_parent"):
      extmethods = getattr(self._parent, "_extmethods", None)
      self._extmethods = extmethods
    else:
      self._extmethods = False
    self.__strip_vlan_tvf = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'outer': {'value': 1}},), is_leaf=True, yang_name="strip-vlan-tvf", rest_name="strip-vlan", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Vlan Header stripping config', u'alt-name': u'strip-vlan'}}, namespace='urn:brocade.com:mgmt:brocade-ip-policy', defining_module='brocade-ip-policy', yang_type='enumeration', is_config=True)
    self.__next_hop_tvf_domain = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4096']}), is_leaf=True, yang_name="next-hop-tvf-domain", rest_name="next-hop-tvf-domain", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-ip-policy', defining_module='brocade-ip-policy', yang_type='tvf-domain:tvf-domain-type', is_config=True)

    load = kwargs.pop("load", None)
    if args:
      if len(args) > 1:
        raise TypeError("cannot create a YANG container with >1 argument")
      all_attr = True
      for e in self._pyangbind_elements:
        if not hasattr(args[0], e):
          all_attr = False
          break
      if not all_attr:
        raise ValueError("Supplied object did not have the correct attributes")
      for e in self._pyangbind_elements:
        nobj = getattr(args[0], e)
        if nobj._changed() is False:
          continue
        setmethod = getattr(self, "_set_%s" % e)
        if load is None:
          setmethod(getattr(args[0], e))
        else:
          setmethod(getattr(args[0], e), load=load)

  def _path(self):
    if hasattr(self, "_parent"):
      return self._parent._path()+[self._yang_name]
    else:
      return [u'routing-system', u'route-map', u'content', u'precedence', u'set', u'next-hop-tvf-domain-container']

  def _rest_path(self):
    if hasattr(self, "_parent"):
      if self._rest_name:
        return self._parent._rest_path()+[self._rest_name]
      else:
        return self._parent._rest_path()
    else:
      return [u'route-map', u'precedence', u'set']

  def _get_next_hop_tvf_domain(self):
    """
    Getter method for next_hop_tvf_domain, mapped from YANG variable /routing_system/route_map/content/precedence/set/next_hop_tvf_domain_container/next_hop_tvf_domain (tvf-domain:tvf-domain-type)
    """
    return self.__next_hop_tvf_domain
      
  def _set_next_hop_tvf_domain(self, v, load=False):
    """
    Setter method for next_hop_tvf_domain, mapped from YANG variable /routing_system/route_map/content/precedence/set/next_hop_tvf_domain_container/next_hop_tvf_domain (tvf-domain:tvf-domain-type)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_next_hop_tvf_domain is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_next_hop_tvf_domain() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4096']}), is_leaf=True, yang_name="next-hop-tvf-domain", rest_name="next-hop-tvf-domain", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-ip-policy', defining_module='brocade-ip-policy', yang_type='tvf-domain:tvf-domain-type', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """next_hop_tvf_domain must be of a type compatible with tvf-domain:tvf-domain-type""",
          'defined-type': "tvf-domain:tvf-domain-type",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4096']}), is_leaf=True, yang_name="next-hop-tvf-domain", rest_name="next-hop-tvf-domain", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-ip-policy', defining_module='brocade-ip-policy', yang_type='tvf-domain:tvf-domain-type', is_config=True)""",
        })

    self.__next_hop_tvf_domain = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_next_hop_tvf_domain(self):
    self.__next_hop_tvf_domain = YANGDynClass(base=RestrictedClassType(base_type=RestrictedClassType(base_type=long, restriction_dict={'range': ['0..4294967295']}, int_size=32), restriction_dict={'range': [u'1..4096']}), is_leaf=True, yang_name="next-hop-tvf-domain", rest_name="next-hop-tvf-domain", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, namespace='urn:brocade.com:mgmt:brocade-ip-policy', defining_module='brocade-ip-policy', yang_type='tvf-domain:tvf-domain-type', is_config=True)


  def _get_strip_vlan_tvf(self):
    """
    Getter method for strip_vlan_tvf, mapped from YANG variable /routing_system/route_map/content/precedence/set/next_hop_tvf_domain_container/strip_vlan_tvf (enumeration)
    """
    return self.__strip_vlan_tvf
      
  def _set_strip_vlan_tvf(self, v, load=False):
    """
    Setter method for strip_vlan_tvf, mapped from YANG variable /routing_system/route_map/content/precedence/set/next_hop_tvf_domain_container/strip_vlan_tvf (enumeration)
    If this variable is read-only (config: false) in the
    source YANG file, then _set_strip_vlan_tvf is considered as a private
    method. Backends looking to populate this variable should
    do so via calling thisObj._set_strip_vlan_tvf() directly.
    """
    if hasattr(v, "_utype"):
      v = v._utype(v)
    try:
      t = YANGDynClass(v,base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'outer': {'value': 1}},), is_leaf=True, yang_name="strip-vlan-tvf", rest_name="strip-vlan", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Vlan Header stripping config', u'alt-name': u'strip-vlan'}}, namespace='urn:brocade.com:mgmt:brocade-ip-policy', defining_module='brocade-ip-policy', yang_type='enumeration', is_config=True)
    except (TypeError, ValueError):
      raise ValueError({
          'error-string': """strip_vlan_tvf must be of a type compatible with enumeration""",
          'defined-type': "brocade-ip-policy:enumeration",
          'generated-type': """YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'outer': {'value': 1}},), is_leaf=True, yang_name="strip-vlan-tvf", rest_name="strip-vlan", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Vlan Header stripping config', u'alt-name': u'strip-vlan'}}, namespace='urn:brocade.com:mgmt:brocade-ip-policy', defining_module='brocade-ip-policy', yang_type='enumeration', is_config=True)""",
        })

    self.__strip_vlan_tvf = t
    if hasattr(self, '_set'):
      self._set()

  def _unset_strip_vlan_tvf(self):
    self.__strip_vlan_tvf = YANGDynClass(base=RestrictedClassType(base_type=unicode,                                     restriction_type="dict_key",                                     restriction_arg={u'outer': {'value': 1}},), is_leaf=True, yang_name="strip-vlan-tvf", rest_name="strip-vlan", parent=self, path_helper=self._path_helper, extmethods=self._extmethods, register_paths=True, extensions={u'tailf-common': {u'info': u'Vlan Header stripping config', u'alt-name': u'strip-vlan'}}, namespace='urn:brocade.com:mgmt:brocade-ip-policy', defining_module='brocade-ip-policy', yang_type='enumeration', is_config=True)

  next_hop_tvf_domain = __builtin__.property(_get_next_hop_tvf_domain, _set_next_hop_tvf_domain)
  strip_vlan_tvf = __builtin__.property(_get_strip_vlan_tvf, _set_strip_vlan_tvf)


  _pyangbind_elements = {'next_hop_tvf_domain': next_hop_tvf_domain, 'strip_vlan_tvf': strip_vlan_tvf, }


